function [f, opt] = fcnLevy30(x, ij)
% 
% Levy function 
% Matlab Code by A. Hedar (Nov. 23, 2005).
% The number of variables n should be adjusted below.
% The default value of n =30.
% For every n the optimum should be "0"!
% 
n = 30;
opt = 0;
if nargin==0
    f = [-10*ones(1,n);
        10*ones(1,n)];
else
    for i = 1:n 
        z(i) = 1+(x(i)-1)/4; 
    end
    s = sin(pi*z(1))^2;
    for i = 1:n-1
        s = s+(z(i)-1)^2*(1+10*(sin(pi*z(i)+1))^2);
    end 
    f = s+(z(n)-1)^2*(1+(sin(2*pi*z(n)))^2);
end